#include <stdlib.h>
#include <stdio.h>
#include "area_common.h"
#include <omp.h>

int main(int argc, char **argv) {
    area_info_t params;
    params.arch = (char*)"openmp";
    area_init(argc, argv, &params, true);


    area_begin(&params, true);

    if(params.threads == 0)
        params.threads = omp_get_num_procs();
    omp_set_num_threads(params.threads);
    
    long double area = 0;
#pragma omp parallel firstprivate(params)
    {
        threadRank=omp_get_thread_num();
        long long i;
#pragma omp for reduction(+:area) schedule(static)
	for(i = 0; i < params.segments; ++i)
        {
           long double x = params.start + ( i * params.delta );
           long double y1 = params.op(x);
           long double y2 = params.op(x + params.delta);
            area += (y1 + y2) * .5 * params.delta;
        }
    }
    #pragma omp barrier
    cputimes = (double *)malloc(sizeof(double));
    cputimes[0] = getCPUTime();
    area_end(&params, area, true);
    area_finish(&params, true);
    return EXIT_SUCCESS;
}
